/*

  LL_DBU : Lowe_Level DBU.
   
  Not a real DBU, only an experimental work with very limited DB operations.
  
  Primary goal of this project is access, detect, inspect and digg a damaged table.
  
  Reasons of damage may be various, so recovery method too depends damage type.
  
  This program open a table by Lowe_Level file access and read methods. 
  
  A second usage may be inspecting how data recorded into a table; always in the visible form or not.
  
  I also tried some function to easy using of Virtual Grid. The virtual grid is a very handy control
  (even have more possibilities than standard Grid). But don't have AddItems and Refresh methods. 
  This program have two little functions for this purpose ( VGridAddItem() and VGridRefresh() ).

  Another interesting point may be showing how can be implement "returning beginning of procedure" from anywhere 
  of that procedure ( procedure : LL_UseTable() ). 
    
  I hope that my friends find useful this humble work.
  
  A last word : Again ( like my previous contribution ) this project too use my little and humble library: libhill.a.  
  I'm sorry for this. But I have some personal reasons.
  
  Happy HMG'ing :D
  
  Bicahi Esgici
  
  2010, 12, 21
  
*/


#include "hmg.ch"

#command EXIT <x> => exit

PROCEDURE Main( cTableNam )

   LOCAL nTblInfNo := 0
   
   LOCAL aButtons := { { "  ", "Go to first record",    430,  96  },;  
                       { " < ", "Go to previous record", 430, 212  },;  
                       { " > ", "Go to next record",     430, 328  },;  
                       { "  ", "Go to last record",     430, 444  } }  
                       
   LOCAL nButton  :=  0,;
         cBtnName := '',;
         cBtnCapt := '',;
         cBtnTTip := '',;
         nBttnRow :=  0,;
         nBttnCol :=  0
   
   SET CENT ON
   
   SET DATE GERM
   
   aTblInfo   := {}
   aTableStru := ARRAY( 10 )  
   AFILL( aTableStru, {'','','','',''} )
   
   aTInfGrdItems  := {}
   
   nFileHandle := 0
   nFileLength := 0
   nFilePointr := 0
   nTblHdrLeng := 0
   nTblRecLeng := 0
   
   aFInfNams  := { { 'Type', 'Table Type'           },; 
                   { 'UDat', 'Last Update Date'     },;
                   { 'HLen', 'Header Length'        },;
                   { 'RLen', 'Record Length'        },;
                   { 'RCou', 'Record Count'         },;
                   { 'FCou', 'Field Count'          },;
                   { 'FSzC', 'File Size (Computed)' } }
                   
   AEVAL( aFInfNams, { | a1 | AADD( aTInfGrdItems, { a1[ 2 ], '' } ) } )
   
   aRecoData := {}
   
   DEFINE WINDOW frmLLDBUMain ;
       AT 0,0 ;
       WIDTH 630 ;
       HEIGHT 550;
       TITLE 'LLDBU ( Low-level DBA )' ;  
       ON INIT LL_UseTable( cTableNam ) ;
       MAIN 
   
       ON KEY ESCAPE ACTION frmLLDBUMain.Release

       DEFINE TAB tabLLDBUMain ;
          OF     frmLLDBUMain  ;
          AT     10, 10        ;
          WIDTH  600           ;
          HEIGHT 530           ;
          VALUE 1              
       
          DEFINE PAGE 'Table Info'
             
             DEFINE GRID  grdTblInfo
                 PARENT   frmLLDBUMain
                 ROW      30
                 COL      100
                 FONTNAME 'FixedSys'       
                 WIDTH    380
                 HEIGHT   180 
                 HEADERS  { 'Info Name', 'Info Data' }
                 WIDTHS   { 130, 250 }             
                 ON QUERYDATA VGridAddItem( aTInfGrdItems )
                 
                 VIRTUAL  .T.  
                 
                 ITEMCOUNT LEN( aTInfGrdItems ) 
                 
             END GRID // grdTblData 
             
             DEFINE GRID  grdTblStru 
                 PARENT   frmLLDBUMain
                 ROW      220 
                 COL      100
                 FONTNAME 'FixedSys'       
                 WIDTH    380
                 HEIGHT   250
                 HEADERS  { 'No', 'Field Name', 'Type', 'Width', 'Dec' }
                 WIDTHS   { 30, 100, 120, 60, 60 }             
                 
                 COLUMNCONTROLS { {'TEXTBOX','CHARACTER'}          ,;
                                  {'TEXTBOX','CHARACTER'}          ,;
                                  {'TEXTBOX','CHARACTER'}          ,;
                                  {'TEXTBOX','NUMERIC','99,9999'}  ,;
                                  {'TEXTBOX','NUMERIC','99'}       } 
                                  
                 ON QUERYDATA VGridAddItem( aTableStru )
                 
                 VIRTUAL  .T.  
                 
                 ITEMCOUNT LEN( aTableStru ) 
                 
             END GRID // grdTblStru              
                       
              
          END PAGE // TabPage&DBInfo
       
          /*   
       
             Second page of Tab ( record data : fields names and their contents )
       
          */   
          
          DEFINE PAGE 'Record Data'
             DEFINE GRID  grdTblData
                 PARENT   frmLLDBUMain
                 ROW      30
                 COL      10
                 FONTNAME 'FixedSys'       
                 WIDTH    580
                 HEIGHT   380 
                 HEADERS  { 'Field Name', 'Field Content' }
                 WIDTHS   { 80, 500 }             
                                  
                 ON QUERYDATA VGridAddItem( aRecoData )
                 
                 VIRTUAL  .T.  
                 
             END GRID // grdTblData 
       
             FOR nButton := 1 TO LEN( aButtons )
             
                 cBtnName := "btnNav_" + LTRIM( STR( nButton ) )
                 cBtnCapt := aButtons[ nButton, 1 ]
                 cBtnTTip := aButtons[ nButton, 2 ]
                 nBttnRow := aButtons[ nButton, 3 ]
                 nBttnCol := aButtons[ nButton, 4 ]
                 
                 DEFINE BUTTON &cBtnName
                    PARENT   frmLLDBUMain
                    ROW nBttnRow
                    COL nBttnCol
                    CAPTION cBtnCapt
                    ONCLICK LL_SKIP( VAL( RIGHT( This.Name, 1 ) ) )
                    WIDTH 20
                    HEIGHT 20
                    FONTNAME "FixedSys"
                    FONTSIZE 15
                    FONTBOLD .T.
                    TOOLTIP cBtnTTip
                 END BUTTON // &cBtnName 
                 
             NEXT nButton   
          
          END PAGE // TabPage&Record
          
       END TAB // tabLLDBUMain
 
       DEFINE CONTEXT MENU OF frmLLDBUMain
          ITEM 'LL_UseTable' ACTION LL_UseTable()
       END MENU
       
       DEFINE STATUSBAR FONT 'Verdana' SIZE 8   
          STATUSITEM "" WIDTH 400
          STATUSITEM "" WIDTH 40
          DATE          WIDTH 80
          CLOCK         WIDTH 83
       END STATUSBAR
       
   END WINDOW
   
   frmLLDBUMain.Center
   frmLLDBUMain.Activate
   
   RETURN // Main()

*.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._

/*
   An example procedure to show how can be implement "returning beginning of procedure" from anywhere of that procedure.
*/
PROCEDURE LL_UseTable(;                        // Lov-lewel USE (open) table
                    cTableNam )
                    
   LOCAL aTGHas      := {},;
         nFVSnFT     :=  0    // file's validity status and file type 
         
   WHILE .T.      
      IF HB_ISNIL( cTableNam )
         cTableNam := GetFile ( { { 'Tables', '*.dbf' }, { 'All Files', '*.*' } },;          // acFilter
                                'Select Table',;   // cTitle 
                                ,;                 // cDefaultPath 
                                .F.,;              // lMultiSelect 
                                .F. )              // lNoChangeDir 
      ENDIF
      
      IF !EMPTY( cTableNam ) .AND. FILE( cTableNam )
      
         aTblInfo := HL_DBInfoLL( cTableNam, .F. ) 
         
         nFVSnFT  := aTblInfo[ 1 ] 
         
         IF nFVSnFT > 0                // Valid Table
         
            nFileHandle := aTblInfo[ 2 ]
            nTblHdrLeng := aTblInfo[ 3, 1, 2, 3, 2 ] 
            nTblRecLeng := aTblInfo[ 3, 1, 2, 4, 2 ] 
            nFileLength := FSEEK( nFileHandle, 0, 2 )
            nFilePointr := FSEEK( nFileHandle, nTblHdrLeng, 0 )
         
            
            aTGHas   := aTblInfo[ 3, 1, 2 ]
            frmLLDBUMain.STATUSBAR.Item( 1 ) := aTGHas[ 1, 2 ]  // Full file name
            aTGHas[ 1, 1 ] := "Type"                            
            aTGHas[ 1, 2 ] := HL_TablTypeNam( nFVSnFT )
            AEVAL( aTInfGrdItems, { | a1, i1 | a1[ 2 ] := aTGHas[ i1, 2 ] } )
            VGridRefresh( "frmLLDBUMain", "grdTblInfo" )
            aTableStru := aTblInfo[ 3, 2, 2 ]
            AEVAL( aTableStru, { | a1, i1 | ASIZE( a1, 5 ), AINS( a1, 1 ), a1[ 1 ] := STR( i1, 3 ) } )
            AEVAL( aTableStru, { | a1 | a1[ 3 ] += " ( " +  HL_FldTypC2V( a1[ 3 ] ) + " )" } )
      
            frmLLDBUMain.grdTblStru.ItemCount := LEN( aTableStru ) 
            VGridRefresh( "frmLLDBUMain", "grdTblStru" )
      
            /*
               Page - 2
            */
            
            aRecoData := { { '<Deleted>', '' } }
               
            AEVAL( aTableStru, { | a1 | AADD( aRecoData, { a1[ 2 ], '' } ) } ) 
            
            frmLLDBUMain.grdTblData.ItemCount := LEN( aTableStru ) + 1  // +1 for "deleted" mark 
            VGridRefresh( "frmLLDBUMain", "grdTblData" )
            
            LL_SKIP( 1 ) // Go Top
            EXIT
         ELSE
            MsgSTop( "Can't open (USE). This file probably isn't a table")
            cTableNam := NIL
            * Here is LOOP point for return beginning of procedure/function. But it's unnecessary in this approach.
         ENDIF nFVSnFT > 0  
      ELSE
         EXIT   
      ENDIF
   ENDDO .T.
RETURN // LL_UseTable()

*.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._

PROCEDURE VGridRefresh(;
                         cWindName,;
                         cGridName ) 

   LOCAL nGrdValue := 0,;
         nGrdItmCo := GetProperty( cWindName, cGridName, "ItemCount" ) 
 
   FOR nGrdValue := 1 TO nGrdItmCo
      SetProperty( cWindName, cGridName, "Value", nGrdValue ) 
   NEXT nGrdValue 
    
   SetProperty( cWindName, cGridName, "Value", 1 ) 
   
RETURN // VGridRefresh()

*.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._



PROCEDURE VGridAddItem(;
                          aGridItems )
                                                      
  IF This.QueryRowIndex <= LEN( aGridItems )  
   
      This.QueryData := aGridItems[ This.QueryRowIndex, This.QueryColIndex ]
   
  ENDIF      
      
RETURN // VGridAddItem()

*.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._

PROCEDURE LL_SKIP( nSkip )           // Lov-lewel skip

   LOCAL nCurrRRN := 0               // Current Relative Record Number
   
   DO CASE
   
      CASE nSkip == 1  // Go Top
         nFilePointr := FSEEK( nFileHandle, nTblHdrLeng, 0 )
      CASE nSkip == 2  // Go Prev
         nFilePointr := FSEEK( nFileHandle, nFilePointr - nTblRecLeng, 0 )
      CASE nSkip == 3  // Go Next
         nFilePointr := FSEEK( nFileHandle, nFilePointr + nTblRecLeng, 0 )
      CASE nSkip == 4  // Go Bottom
         nFilePointr := FSEEK( nFileHandle, nTblRecLeng, 2 )
   
   END CASE // nSkip
   
   nFilePointr := MAX( MIN( nFilePointr, nFileLength - nTblRecLeng - 1 ), nTblHdrLeng )
   
   FSEEK( nFileHandle, nFilePointr, 0 )   
   
   nCurrRRN := ( nFilePointr - nTblHdrLeng ) / nTblRecLeng + 1
   
   frmLLDBUMain.STATUSBAR.Item( 2 ) := PADC( HL_MTrim( nCurrRRN ), 8 ) // nCurrRRN 
   
   LL_DispReco()
   
RETURN // LL_SKIP( nSkip )

*.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._

PROCEDURE LL_DispReco()

   LOCAL cRecStr := SPACE( nTblRecLeng ),;
         nRBytes := 0
         
   LOCAL aClTblStru := { { '', '<Deleted>', '', 1, 0 } }
   
   LOCAL nFldNum :=  0,;
         nFldPos :=  1,;
         nFldLen :=  0,;
         cFldDat := '',;
         aRecDat := {}
         
   AEVAL( aTableStru, { | a1 | AADD( aClTblStru, a1 ) } )     
   
   nRBytes := FREAD( nFileHandle, @cRecStr, nTblRecLeng ) 
   
   IF nRBytes # nTblRecLeng
      HL_BTV( "Low level file read error" )
   ELSE   
      FOR nFldNum := 1 TO LEN( aClTblStru )
         nFldLen := aClTblStru[ nFldNum, 4 ]   
         cFldDat := SUBSTR( cRecStr, nFldPos, nFldLen )
         IF HL_IsIncCtrl( cFldDat )
            cFldDat := '0x' + HL_Strg2Hex( cFldDat ) + '( ' + cFldDat + ' )'
         ENDIF   
         AADD( aRecDat, cFldDat )   
         nFldPos += nFldLen
      NEXT nFldNum 
      
      AEVAL( aRecDat, { | c1, i1 | aRecoData[ i1, 2 ] := c1 } )
      
      VGridRefresh( "frmLLDBUMain", "grdTblData" )

   ENDIF
       
   
RETURN // LL_DispReco()

*.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._

